// LST10_03.CPP
// Program demonstrates using static data members to count
// the number of class instances

#include <iostream.h>
#include <conio.h>

const unsigned MIN_SIZE = 4;

class Array
{
  protected:
    unsigned *dataPtr;
    unsigned size;
    static unsigned countInstances;

  public:
    Array(unsigned Size = MIN_SIZE);
    Array(Array& ar);
    ~Array();
    unsigned getSize() const
      { return size; }
    static unsigned getCountInstances()
      { return countInstances; }  
    void store(unsigned x, unsigned index)
      { dataPtr[index] = x; }
    unsigned recall(unsigned index)
      { return dataPtr[index]; }
    Array& copy(Array& ar);
};

Array::Array(unsigned Size)
{
  size = (Size < MIN_SIZE) ? MIN_SIZE : Size;
  dataPtr = new unsigned[size];
  countInstances++;
}

Array::Array(Array& ar)
{
 copy(ar);
 countInstances++;
}

Array::~Array()
{ 
 delete [] dataPtr;
 countInstances--;
}
 
Array& Array::copy(Array& ar)
{    
  delete[] dataPtr; //delete the current array
  // make size of instancece equal to size of argument
  size = ar.size;
  // re-create new array
  dataPtr = new unsigned[size];
  // copy elements
  for( unsigned i = 0; i < size; i++)
   dataPtr[i] = ar.dataPtr[i];
  return *this;
}

// initialize the static member
unsigned Array::countInstances = 0;

main()
{ unsigned i;
  Array Ar1;
  
  for( i = 0; i < Ar1.getSize(); i++)
    Ar1.store(i*i, i);

  clrscr();
  
  cout<<"Array Ar1 has thr following values:\n\n";
  for( i = 0; i < Ar1.getSize(); i++)
    cout << "Ar1 [ " << i << " ] = " << Ar1.recall(i) <<"\n";

  cout << "\nThere are  " << Array::getCountInstances()
       << " istance(s) of class Array"
       << "\n\nPress any key to continue..."; 
  getch();

  
  {
    Array Ar2(6);

    clrscr();

    for( i = 0; i < Ar2.getSize(); i++)
      Ar2.store(i + 2, i);

    cout<<"Array Ar2 has thr following values:\n\n";
    for( i = 0; i < Ar2.getSize(); i++)
    cout << "Ar2 [ " << i << " ] = " << Ar2.recall(i) <<"\n";

    cout << "\nThere are  " << Array::getCountInstances()
         << " istance(s) of class Array"
         << "\n\nPress any key to continue..."; 

    getch();

    // copy elements of array Ar2 to array Ar1
    Ar1.copy(Ar2);

  }

  clrscr();
  cout << "Expanded array Ar1 (=Array Ar2)"
       << " has the following values:\n\n";
  for( i = 0; i < Ar1.getSize(); i++)
    cout << "Ar1 [ " << i << " ] = " << Ar1.recall(i) << "\n";
  cout << "\nThere are " << Array::getCountInstances()
       << " instance(s) of class Array";
       
  //return 0;
}  
  
        
        
