// LST10_05.CPP
// Program demonstrates operatores and friend operatores

#include <iostream.h>
#include<conio.h>

class Complex
{
 protected:
   double real;
   double imag;

 public:
  Complex(double Real = 0, double Imag = 0)
  { assign(Real, Imag); }
  Complex(Complex& c);
  void assign(double Real = 0, double Imag = 0);
  double getReal() const
    { return real; }  
  double getImag() const
    { return imag; }
  Complex& operator =(Complex& c);
  Complex& operator +=(Complex& c);  
  friend Complex operator +(Complex& c1, Complex& c2);
  friend ostream& operator <<(ostream& os, Complex& c);
};

Complex::Complex(Complex& c)
{
  real = c.real;
  imag = c.imag;
}

void Complex::assign(double Real, double Imag)
{
 real = Real;
 imag = Imag;
}

Complex& Complex::operator =(Complex& c)
{
  real = c.real;
  imag = c.imag;

  return *this;
}
 
Complex& Complex::operator +=(Complex& c)
{
  real += c.real;
  imag += c.imag;

  return *this;
}

Complex operator +(Complex& c1, Complex& c2)
{
  Complex result(c1);
  
  result.real += c2.real;
  result.imag += c2.imag;

  return result;
}

ostream& operator <<(ostream& os, Complex& c)
{
  os << " ( " << c.real
     <<" + i*"<< c.imag << ")";

  return os;
}     

main()
{
 Complex c1(1, 1);
 Complex c2(2, 2);
 Complex c3;
 Complex c4(4, 4);
 
 clrscr();

 c3 = c1 + c2;
 cout << c1 << " + " << c2 <<" = " << c3 <<"\n\n";
 cout << c3 << " + " << c4 << " = ";
 c3+=c4;
 cout << c3 << "\n\n";

 //return 0;
}
