// Prosta klasa Tablica (dla liczb calkowitych)
//#ifndef TABLICA1_H
//#define TABLICA1_H

#include <iostream.h>
//#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <assert.h>
//#include "tablica1.h"
//#include <iostream.h>
#include <conio.h>
//#include"tablica1.h"

class Tablica{
   friend ostream &operator<<(ostream &, const Tablica & );
   friend istream &operator>>( istream &, Tablica & );
 public:
   Tablica(int = 10);                // konstruktor domyslny
   Tablica(const Tablica &);         // konstruktor kopiujacy
   ~Tablica();                       // destruktor
   int pobierzRozmiar() const;       // zwraca rozmiar
   const Tablica &operator=(const Tablica &); // przypisanie tablicy
   bool operator==(const Tablica &) const;    // operator porownania
   bool operator!=(const Tablica &prawa) const
        { return !(*this == prawa); }
   int &operator[](int);              // operator indeksu
   const int &operator[](int) const;  // operator indeksu
   static int pobierzLiczbeTablic();  // zwraca liczbe obiektow
 private:
   int rozmiar;                       // rozmiar tablicy
   int *ptr;                          // wskaznik do pierwszego elementu tablicy
   static int liczbaTablic;           // liczba utworzonych tablic;
};

//#endif       
    

int Tablica::liczbaTablic = 0; 


Tablica::Tablica(int rozmiarTablicy)
{
  rozmiar = (rozmiar >  0 ? rozmiarTablicy : 10);
  ptr = new int[rozmiar]; // zarezerwuj miejsce na tablice
  assert(ptr != 0);       // zakoncz, jezeli nie zaalokowano
  ++liczbaTablic;         // dodaj kolejny obiekt

  for(int i = 0; i < rozmiar; i++)
   ptr[i] = 0;  

  cout << konstukto           // zainicjowanie tablicy
}

// konstruktor kopiujacy klasy Tablica
// musi otrzymac referencje, aby uniknac nieskonczonego wywolywania
Tablica::Tablica(const Tablica &inic) : rozmiar(inic.rozmiar)
{   
  ptr = new int[rozmiar];   // zarezerwuj miejsce na tablice
  assert(ptr != 0);        // zakoncz, jezeli nie zaalokowano 
  ++liczbaTablic;          // dodaj kolejny obiekt

  for(int i = 0; i < rozmiar; i++)
   ptr[i] = inic.ptr[i];            // kopiowanie inic do obiektu     
}

// Destruktor klasy Tablica
Tablica::~Tablica()
{
  delete [] ptr;                    // zwolnij pamiec tablicy
  --liczbaTablic;                   // jeden obiekt mniej
}

// Pobierz rozmiar tablicy
int Tablica::pobierzRozmiar() const { return rozmiar; }

// Przeciazony operator przypiania
// zwracnie stalej unika: (t1 = t2) = t3
const Tablica &Tablica::operator=(const Tablica &prawa)
{
  if( &prawa != this ) { // sprawdz, czy przypisanie samej sobie
    // jezeli tablice maja rozne wielkosci, zwolnij pamiec dla
    // tablicy z lewej strony, nastepnie zaalokuj ja jeszcze raz
    if(rozmiar != prawa.rozmiar){
     delete [] ptr;              // zwolnij pamiec tablicy
     rozmiar = prawa.rozmiar;    // zmien wielkosc tablicy
     ptr     = new int[rozmiar]; // zaalokuj pamiec na nowe tablice
     assert(ptr != 0);            // zakoncz, jezeli nie zaalokowano
    }
    
    for(int i = 0; i < rozmiar; i++)
        ptr[i] = prawa.ptr[i];   // skopiowanie danych z tablicy
   }

   return *this;                 // umozliwia z = y = z
}

// Sprawdz, czy dwie tablice sa rowne i zwroc true,
// w przeciwnym przypadku zwroc false
bool Tablica::operator==(const Tablica &prawa) const
{
  if(rozmiar != prawa.rozmiar)
   return false;          // tablice maja rozne wielkosci

  for( int i = 0; i < rozmiar; i++)
   if(ptr[i] != prawa.ptr[i])
    return false;         // tablice sa rozne

  return true;            // tablice sa rowne
}

// Przeciazony operator indeksu dla tablic 
// zwrocenie referencji tworzy l-value
int  &Tablica::operator[](int indeks)
{
 // Sprawdz, czy indeks ma odpowiednia wartosc
 assert(0 <= indeks && indeks < rozmiar);

 return ptr[indeks];   // zwrocenie referencji
}                    

// Przeciazony operator indeksu dla tablic 
// zwrocenie stalej referencji tworzy r-value
const int  &Tablica::operator[](int indeks) const
{
 // Sprawdz, czy indeks ma odpowiednia wartosc
 assert(0 <= indeks && indeks < rozmiar);

 return ptr[indeks];   // zwrocenie referencji
}                    

// Zwraca liczbe utworzonych obiektow klasy Tablica
// Funkcja statyczna nie moze byc stala
int Tablica::pobierzLiczbeTablic() { return liczbaTablic; }

// Przeciazony operator wejscia dla klasy Tablica
istream &operator>>(istream &wejscie, Tablica &t)
{
 for(int i = 0; i < t.rozmiar; i++)
  wejscie >> t.ptr[i];

 return wejscie;   // umozliwia >> x >> y;
}

// Przeciazony operator wyjscia dla klasy Tablica
ostream &operator<<(ostream &wyjscie, const Tablica &t)
{
  int i;

  for(int i = 0; i < t.rozmiar; i++){

    wyjscie << setw(12) << t.ptr[i];

    if ((i + 1) % 4 == 0)  // wyswitlenie 4 liczb w wierszu
     wyjscie << endl;
  }

  if (i % 4 != 0)
   wyjscie << endl;

  return wyjscie;  // umozliwia cout << x << y;
}
      
      
     
// Program testujacy klase Tablica

int main()
{
  // nie ma jeszcze zadnego obiektu
  cout << "# utworzonych tablic = "
       << Tablica::pobierzLiczbeTablic() << endl;
  getch();     

  // utworz dwie tablice i wydrukuj licznik tablic
  Tablica calkowite1(7), calkowite2;
  cout << "# utworzonych tablic = "
       << Tablica::pobierzLiczbeTablic() << endl;
  getch();     

  // wyswietl wielkosc tablicy calkowite1 oraz jej zawartosc
  cout << "Rozmiar tablicy calkowite1 : "
       <<  calkowite1.pobierzRozmiar() << endl;
  cout <<  "Zawartosc tablicy po zainicjalizowaniu : " << endl;
  cout <<  calkowite1 << endl;
  getch();
  
  // wyswietl wielkosc tablicy calkowite2 oraz jej zawartosc
  cout << "Rozmiar tablicy calkowite2 : "
       <<  calkowite2.pobierzRozmiar() << endl;
  cout <<  "Zawartosc tablicy po zainicjalizowaniu : " << endl;
  cout <<  calkowite2 << endl;     
  getch();
  
  // wczytaj i wyswietl calkowite1 oraz calkowite2
  cout << "Podaj 17 liczb calkowitych : " << endl;
  cin >> calkowite1 >> calkowite2;
  getch();
  
  // wyswietl wielkosc tablicy calkowite1 oraz jej zawartosc
  cout <<  "Zawartosc tablicy calkowite1 po zainicjalizowaniu : " << endl;
  cout <<  calkowite1 << endl; 
  cout <<  "Zawartosc tablicy calkowite2 po zainicjalizowaniu : " << endl;
  cout <<  calkowite2 << endl;
  getch();
  
  cout << "Sprawdzenie: calkowite1 != calkowite2" << endl;
   if(calkowite1 != calkowite2)
      cout << "Tablice sa rozne" << endl;
  getch();
  
  // utworz tablice calkowite3 inicjalizujac ja zawartoscia tablicy
  // clkowite1; wyswietl rozmiar oraz zawartosc
  Tablica calkowite3(calkowite1);
  cout << "Rozmiar tablicy calkowite3 : "
       <<  calkowite3.pobierzRozmiar() << endl;
  cout <<  "Zawartosc tablicy po zainicjalizowaniu : " << endl;
  cout <<  calkowite3 << endl;          
  getch();     

  // przypisanie calkowite1 = calkowite2
  cout << " Przypisanie clkowite2 do calkowite1 : " << endl;
  calkowite1 = calkowite2;
  cout <<  "Zawartosc tablicy calkowite1 : " << endl;
  cout <<  calkowite1 << endl; 
  cout <<  "Zawartosc tablicy calkowite2 : " << endl;
  cout <<  calkowite2 << endl;
  getch();

  // test ==
  cout << "Sprawdzenie calkowite1 == calkowite2 " << endl;
   if(calkowite1 == calkowite2)
       cout << "Tablice sa rowne" << endl;
  getch();

  // wykorzystaj przeciazonego operator indeksu tworzac r-value
  cout << "calkowite1[5] =" << calkowite1[5] << endl;
  getch();
    
  // wykorzystaj przeciazonego operator indeksu tworzac l-value
  calkowite1[5] = 1000;
  // wyswietlenie
  cout << "calkowite1[5] =" << calkowite1[5] << endl;      
  getch();
  
  // proba przekroczenia zakresu tablicy
  cout << "Proba przypisania wartosci 1000 elmentowi calkowite1[15]" << endl;
  calkowite1[15] = 1000;    // Blad -> poza zakresem
  getch();
  
  return 0;
}   
       