#include<iostream.h>
#include<iomanip.h>
#include<string.h>
#include<assert.h>
#include"NAPIS.H"

//konstruktor przeksztalcajacy: konwersja char * na Napis
Napis::Napis( const char *s) : dlugosc( strlen( s ) )
{
  cout << "konstruktor przeksztalcajacy: " << s << endl;
  ustawNapis( s );       // wywolanie funkcji narzedziowej
}

//konstruktor kopiujacy
Napis::Napis( const Napis & kopia) : dlugosc( kopia.dlugosc )
{
  cout << "konstruktor kopiujacy: " << kopia.sPtr << endl;
  ustawNapis( kopia.sPtr );   //wywolanie funkcji narzedziowej
}

//destruktor
Napis::~Napis()
{
  cout << "destruktor" << sPtr << endl;
  delete [] sPtr;
}

//przeciazony operator =
const Napis & Napis::operator=( const Napis &prawy )
{
  cout << "wywolanie operatora =" << endl;

  if( &prawy != this ){         // unikanie samoprzypisania
       delete [] sPtr;          // usuniecie zbednych kopii napisu
       dlugosc = prawy.dlugosc; // nowa dlugosc napisu
       ustawNapis( prawy.sPtr );// wywolanie funkcji narzedziowej
  }
  else
   cout << "Proba przypisania obiektu samemu sobie" << endl;
  return *this;
}

// konkatenacja operandu 'prawy' z obiektem this oraz przechowanie
// w nim rezultatu
const Napis & Napis::operator+=( const Napis &prawy )
{
  char *tymczasowyPtr = sPtr;     // zapamietaj, aby usunac
  dlugosc += prawy.dlugosc;      // nowa dlugosdc napisu
  sPtr = new char[ dlugosc + 1];  // zaalokuj pamiec
  assert( sPtr != 0);             // koniec, jesli nie zaalokowano
  strcat( sPtr, tymczasowyPtr );  // lewa czesc nowego napisu
  strcat( sPtr, prawy.sPtr );     // prawa czesc nowego napisu
  delete [] tymczasowyPtr;         // zwolnij stara pamiec
  return *this;
}

// czy napis jest pusty?
bool Napis:: operator!() const { return dlugosc == 0; }


// czy napis jest rowny napisowi podanemu jako argument?
bool Napis:: operator==(const Napis &prawy ) const
   { return strcmp( sPtr, prawy.sPtr ) == 0; }

// czy napis jest mniejszy od napisu podanego jako prawy argument?
bool Napis::operator<( const Napis &prawy ) const
   { return strcmp( sPtr, prawy.sPtr ) < 0; }

// zwroc referencje do znaku w napisie jako l_value
char &Napis::operator[]( int indeks)
{
  // najpierw sprawdz, czy indeks ma odpowiednia wartosc
  assert( indeks >= 0 && indeks < dlugosc );

  return sPtr[ indeks ];  // utworzenie l-value
}

// zwroc referencje do znaku w napisie jako r-value
const char &Napis::operator[]( int indeks) const
{
   // najpierw sprawdz, czy indeks ma odpowiednia wartosc
   assert( indeks >= 0 && indeks < dlugosc);

   return sPtr[ indeks ];  // utworzenie r-value
}

// zwroc podnapis, rozpoczynajacy sie na pozycji indeksu o dlugosci
// dlugoscPodl jako referencje do obiektu Napis
Napis &Napis::operator()( int indeks, int dlugoscPodn)
{
  // sprawdz, czy indeks oraz dlugosc podnapisu sa odpowiednie
  assert( indeks >= 0 && indeks < dlugosc && dlugoscPodn >= 0 );

  Napis *podnPtr = new Napis; // pusty napis
  assert( podnPtr != 0);      // sprawdz, czy napis zostal zaalokowany

  // okreslenie dlugosci podnapisu
  if ( ( dlugoscPodn == 0 ) || (indeks + dlugoscPodn > dlugosc ))
     podnPtr -> dlugosc = dlugosc - indeks + 1;
  else
     podnPtr -> dlugosc = dlugoscPodn + 1;

  // zaalokuj pamiec na podnapis
  delete podnPtr -> sPtr;
  podnPtr -> sPtr = new char[ podnPtr -> dlugosc ];
  assert( podnPtr -> sPtr != 0 ); // sprawdz, czy pamiec jest zaalokowana

  // skopiuj podnpis do nowego napisu
  strncpy( podnPtr -> sPtr, &sPtr[ indeks ], podnPtr -> dlugosc );
  podnPtr -> sPtr[ podnPtr -> dlugosc ] = '\0'; // zakoncz napis

  return *podnPtr;
}

// zwroc dlugosc napisu
int Napis::pobierzDlugosc() const { return dlugosc; }

// funkcja narzedziowa wywolywana przez konstruktory oraz operatory przypisania
void Napis::ustawNapis( const char *Napis2)
{
  sPtr = new char[ dlugosc + 1 ]; // zaalokuj pamiec
  assert(sPtr !=0 );              // koniec, jezeli pamiec nie jest zaalokowana
  strcpy( sPtr, Napis2 );
}

// przeciazony operator wyjscia
ostream &operator<<( ostream &wyjscie, const Napis &s )
{
  wyjscie << s.sPtr;
  return wyjscie;
}

// przeciazony operator wejscia
istream &operator>>( istream &wejscie, Napis &s )
{
  char tymczas[ 100 ]; // bufor przechowujacy dane wejsciowe

  wejscie >> setw( 100 ) >> tymczas;
  s = tymczas;
  return wejscie;
}




