#include<iostream.h>
#include<conio.h>
#include<math.h>

const double pi = 4 * atan(1);

inline double sqr(double x) { return x * x; }

class Circle
{
  protected:

    double radius;

  public:

    Circle(double radiusVal = 0) : radius(radiusVal) {}

    void setRadius(double radiusVal) { radius = radiusVal; }

    double getRadius() const { return radius; }

    virtual double area() const { return pi * sqr(radius); }

    void showData();
};

class Cylinder : public Circle
{
  protected:

    double height;

  public:

    Cylinder(double heightVal = 0, double radiusVal = 0)
                  : height(heightVal), Circle(radiusVal) {}

    void setHeight(double heightVal)
         { height = heightVal; }

    double getHeight() const
         { return height; }

    double volume()
         { return height * area(); }

    void showData();
};

class HollowCylinder : public Cylinder
{
   protected:

    double innerRadius;
      
   public:

    HollowCylinder(double heightVal = 0, double Rin = 0, 
                   double Rout = 0) :
                   innerRadius(Rin), Cylinder(heightVal, Rout) {}

    void setInnerRadius(double Rin)
        { innerRadius = Rin; }

    double getInnerRadius() const
        { return innerRadius; }

    virtual double area() const
        { return pi * (sqr(radius) - sqr(innerRadius)); }

    void showData();
};

void Circle::showData()
{
  cout << "Circle radius       = " << getRadius()        << endl
       << "Circle area         = " << area()             << endl
       << endl;
}

void Cylinder::showData()
{
   cout << "Cylinder radius     = " << getRadius()       << endl
        << "Cylinder height     = " << getHeight()       << endl
        << "Cylinder base area  = " << area()            << endl
        << "Cylinder volume     = " << volume()           << endl
        << endl;
}

void HollowCylinder::showData()
{
   cout << "Hollow radius        = " << getRadius()      << endl
        << "Hollow inner radius  = " << getInnerRadius() << endl
        << "Hollow height        = " << getHeight()      << endl
        << "Cylinder base area   = " << area()           << endl
        << "Hollow volume        = " << volume()        << endl
        << endl;
}

main()
{
   Circle   ci(1);
   Cylinder cy(10,1);
   HollowCylinder ho(10, 0.5,1);
          
   clrscr();

   ci.showData();
   cy.showData();
   ho.showData();

   getch();
   return 0;
}                
   
/*

Circle radius       = 1
Circle area         = 3.14159

Cylinder radius     = 1
Cylinder height     = 10
Cylinder base area  = 3.14159
Cylinder volume     = 31.4159

Hollow radius        = 1
Hollow inner radius  = 0.5
Hollow height        = 10
Cylinder base area   = 2.35619
Hollow volume        = 23.5619

*/

