// File ex5_11.cpp
//
// Template-based description of List class.
//


#include "ex5_10.h"
#include <iostream.h>


// Constructor for List_Node class.
template <class T> List_Node<T>:: List_Node(T val,
				  List_Node<T> *p)
{
  info = val;
  next = p;
}



// Insert function.
template <class T> List_Node<T> *List_Node<T> ::
				 insert(T value)
{
  next = new List_Node<T>(value,next);
  return next;
}



// Constructor for List class.
template <class T> List<T>:: List()
{
  head = 0;
}



// Copy constructor for List class.  It calls the
// recursive routine copy() for the class List_Node.
template <class T> List<T> :: List(const List<T> & from)
{
  if (from.empty())
    head = 0;
  else
    {
    List_Node<T> *temp  = from.head;
    head = temp->copy();
    }
}




// Destructor
template <class T> List<T> :: ~List()
{
  List_Node <T> *runner, *trailer;

  for(trailer = head; trailer != 0; trailer = runner)
    {
    runner = trailer->next;
    trailer->next = 0;
    delete trailer;
    }
}



// Insert new List_Node at front of list.
template <class T> void List<T>::insert(T val)
{
  head = new List_Node<T>(val, head);
}



// Function to determine if List is empty.
// Returns 1 if empty, 0 otherwise.
template <class T> int List<T> :: empty() const
{
  if (head == 0)
    return 1;
  else
    return 0;
}



// Function to return contents of first node in list.
template <class T> T List<T>:: get_data()
{
  return (head->info) ;
}



// Remove first List_Node from head of list.
template <class T> void List<T>:: remove_first()
{
  List_Node<T> *temp = head;
  head = temp->next;
  delete temp;
}










/////////////////////////////////////////
// main() function to test the list class.
/////////////////////////////////////////

main()
{
  int i;
  List<int> list1;
  List<float> list2;
  List<char> list3;
  List_Iterator<int> list_it1(list1);

  for(i = 10; i > 0; i--)
    list1.insert(i);
  list1.insert(77);
  for (list_it1.init(); list_it1.forward != 0; ++list_it1)
    ; // All work is done in iterator.
  cout << endl << endl;
}