// FILE: ex5_14.h
// This is the class description of the class Queue
// for queue manipulation - non-template version.
// The code in this file is a slight modification
// of the code for the non-template implementation
// for the List class given in the file List.h (ex5_8.h).
//

#include <iostream.h>
#include <iomanip.h>

typedef int Item;


class Queue
{
public:
  Queue(Item data);
  ~Queue();
  int empty();
  void insert(Item data);
  Item remove();
  Item iterator();
private:
  struct Node
    {
    Item info;
    struct Node * previous;
    struct Node *next;
    };
  struct Node *front; // head of queue
  struct Node *rear; // rear of queue
};





// Constructor function.
Queue:: Queue(Item data)
{
  Node * temp;

  temp = new Node;
  temp->info = data;
  temp->next = 0;
  temp->previous = 0;
  front = rear = temp;
}




// Destructor function.
Queue:: ~Queue()
{
  struct Node *runner, *trailer;

  for(trailer = front; trailer != 0; trailer = runner)
    {
    runner = trailer->next;
    trailer->next = 0;
    delete trailer;
    }
}




// Function tests if queue is empty.
// Returns 1 if queue is empty, 0 otherwise.
int Queue :: empty()
{
  if (front == rear == 0)
    return 1;
  else
    return 0;
}



// Insert function-- inserts at rear of queue.
void Queue:: insert(Item data)
{
  struct Node * temp;

  temp = new Node;
  temp->info = data;
  temp->previous = rear;
  temp->next = 0;
  rear->next = temp;
  rear = temp;
  cout << "Done insert of "<< data << endl;
}



// Remove an item from the front of the queue.
Item Queue:: remove()
{
  Item data;
  struct Node *temp;

  data = front->info;
  temp = front->next;
  temp->previous = 0;
  delete front;
  front = temp;
  return data;
}



// Queue iterator -- prints contents of queue
// from front to rear and returns contents of rear.
Item Queue:: iterator()
{
  struct Node * runner;
  Item temp_data;

  runner = front;
  temp_data = -999;  // Indicates queue is empty.
  while(runner != 0)
    {
    // Process the contents of the nodes.
    cout << "Iterating the queue." << endl;
    cout << setw(4) << runner->info;
    temp_data = runner->info;
    runner = runner ->next;
    }
  cout << endl;
  return temp_data;
}