//

template <class T> class Queue
{
public:
  Queue(T data);
  ~Queue();
  int empty();
  void insert(T data);
  T remove();
private:
  struct Node
    {
    T info;
    struct Node * previous;
    struct Node *next;
    };
  struct Node *front; // head of queue
  struct Node *rear; // rear of queue
};





// Constructor function.
template<class T> Queue<T>:: Queue(T data)
{
  Node * temp;

  temp = new Node;
  temp->info = data;
  temp->next = 0;
  temp->previous = 0;
  front = rear = temp;
}




// Destructor function.
template <class T> Queue<T>:: ~Queue()
{
  struct Node *runner, *trailer;

  for(trailer = front; trailer != 0; trailer = runner)
    {
    runner = trailer->next;
    trailer->next = 0;
    delete trailer;
    }
}




// Function tests if queue is empty.
// Returns 1 if queue is empty, 0 otherwise.
template <class T> int Queue<T> :: empty()
{
  if (front == rear == 0)
    return 1;
  else
    return 0;
}



// Insert function-- inserts at rear of queue.
template <class T> void Queue<T>:: insert(T data)
{
  struct Node * temp;

  temp = new Node;
  temp->info = data;
  temp->previous = rear;
  temp->next = 0;
  rear->next = temp;
  rear = temp;
  cout << "Done insert of "<< data << endl;
}



// Remove an item from the front of the queue.
template <class T> T Queue<T>:: remove()
{
  T data;
  struct Node *temp;

  data = front->info;
  temp = front->next;
  temp->previous = 0;
  delete front;
  front = temp;
  return data;
}