//
//   FILENAME : ex5_5.cpp
//   FILE CONTAINS FUNCTIONS FOR OPERATIONS ON A STACK
//   STACK IS IMPLEMENTED USING AN ARRAY OF FIXED SIZE
//   ELEMENTS OF THE ARRAY ARE OF THE TYPE GIVEN BY A
//   typedef STATEMENT AS BEING OF TYPE STACK_ITEM
//   STACK_ITEM is a synonym for int
//   A STACK is an abstract data type
//   elements on STACK are of type STACK_ITEM
//   CONSTANTS ARE IN THE FILE stack.h
//
//   FUNCTIONS IN FILE:
//              Stack();        // Constructor
//              int empty();
//              initialize()
//              void push(STACK_ITEM)
//              STACK_ITEM pop()

#include <iostream.h>
#include "ex5_4.h"             // "stack.h"

// New function needed because of new declaration
// initializes the stack top to -1
void Stack :: initialize(void)
{
  top = -1;
};


// Pushes an argument onto the stack if not full.  If
// stack was already full, then print error message.
void Stack :: push (STACK_ITEM n)
{
  if (top < MAXSTACK - 1)
    {
    top++;
    item[top] = n;
    }
  else
    cout << "error -- stack full.\n";
}

 
// Pops the top value off stack. Prints an error message
// if one tries to "pop" from an empty stack.
// A negative value for top means that the stack is empty.
STACK_ITEM Stack :: pop()
{
  int temp = top;

  if (top >= 0)
    {
    top--;
    return (item[temp]);
    }
  else
    {
    cerr << "error -- stack empty.\n";
    return (0); // stack empty: return 0 to clear stack.
    }
}