#include<iostream.h>
#include<fstream.h>
#include<iomanip.h>
#include<stdlib.h>
#include "klntdane.h"

int  wezWybor(void);
void plikTekst(fstream&);
void aktuRekord(fstream&);
void nowyRekord(fstream&);
void kasujRekord(fstream&);
void wyWiersz(ostream&, const klientDane);
int  wezKonto(const char *);

enum Wybor { PLIKTEKST = 1, AKTUALIZ, NOWY, KASUJ, KONIEC };

main()
{
  fstream weWyKredyt("kredyt.dat", ios::in | ios::out );

  if(!weWyKredyt)
  { cerr << "Plik nie moze byc otwarty." << endl;
    exit(1);
  }

  int wybor;

  while(( wybor = wezWybor()) !=KONIEC)
  { 
   switch(wybor){
     case PLIKTEKST: plikTekst(weWyKredyt);
                     break;
     case AKTUALIZ : aktuRekord(weWyKredyt);
                     break;
     case NOWY     : nowyRekord(weWyKredyt);
                     break;
     case KASUJ    : kasujRekord(weWyKredyt);
                     break;
     default       : cerr << "Niewlasciwy wybor" << endl;
                     break;
   }

   weWyKredyt.clear(); // resetuj wskaznik konca plikiu
 }                                                                     
 return 0;
}

// menu
int wprowadzWybor()
{ 
  cout << "\nWprowadz wybor" << endl
       << "1 - zapisz sformatowany plik tekstowy kont" << endl
       << "    \"druk.txt\" da pozniejszego wydruku" << endl
       << "2 - aktualizuj konto" << endl
       << "3 - dodaj nowe konto" << endl
       << "4 - skasuj konto" << endl
       << "5 - koniec programu?" ;
       

   int    menuWybor;
   cin >> menuWybor;
   return menuWybor;
}

// stworz sformatowany plik tekstowy do wydruku
void plikTekst(fstream &czytPlik)
{
  ofstream wyPlikWydruku("druk.txt", ios::out);

  if(!wyPlikWydruku)
  { cerr << "Plik nie moze byc otwarty." << endl;
    exit(1);
  }

  wyPlikWydruku << setiosflags(ios::left) << setw(10)
                << "Konto" << setw(16)
                << "Nazwisko" << setw(11)
                << "Imie" <<resetiosflags(ios::left)
                << setw(10) << "bILANS" << endl;

  czytPlik.seekg(0);                

  klientDane klient;
  czytPlik.read(reinterpret_cast<char *>(&klient),
                sizeof(klientDane));
                
  while(!czytPlik.eof())
  { if(klient.kontoNumer !=0)
       wyWiersz(wyPlikWydruku, klient);
       
    czytPlik.read(reinterpret_cast<char *>(&klient),
                  sizeof(klientDane));
  }
}

// uaktualnij bilans konta
void aktuRekord(fstream &aktuPlik)
{
  int konto = wezKonto("Wprowadz konto do uaktualnienia");

  aktuPlik.seekg((konto - 1) * sizeof(klientDane));

  klientDane klient;
  aktuPlik.read(reinterpret_cast<char *>( &klient),
                sizeof(klientDane));

  if(klient.kontoNumer !=0){
     wyWiersz(cout, klient);
     cout << "\nWyprowadz wplate (+) albo wyplate (-):";
     float transakcja;
     cin >> transakcja;
     klient.bilans += transakcja;
     wyWiersz(cout, klient);
     aktuPlik.seekp((konto - 1) * sizeof(klientDane));
     aktuPlik.write(reinterpret_cast<char *>(&klient),
                    sizeof(klientDane));
  }
  else
   cerr << "Konto #" << konto
        << " nie zawiera informacji." << endl;
}

// utworz i wstaw nowy rekord
void nowyRekord(fstream &wstawDoPliku)
{
 int konto = wezKonto("Wprowadz nowy numer konta");

 wstawDoPliku.seekg((konto - 1) * sizeof(klientDane));

 klientDane klient;
 wstawDoPliku.read(reinterpret_cast<char *>(&klient),
                   sizeof(klientDane));

 if(klient.kontoNumer == 0)
 {
  cout << "Wprowadz nazwisko, imie, bilans\n?";
  cin  >> klient.Nazwisko >> klient.Imie
       >> klient.bilans;

  klient.kontoNumer == konto;

  wstawDoPliku.seekp((konto - 1)* sizeof(klientDane));

  wstawDoPliku.write(reinterpret_cast<const char *>(&klient),
                     sizeof(klientDane));
 }
 else
   cerr << "Konto # " << konto
        << " zawiera juz informacje. " << endl;
}

// skasuj istniejacy rekord
void kasujRekord(fstream &kasujPlik)
{
 int konto = wezKonto("Wprowadz konto do skasowania");

 kasujPlik.seekg((konto - 1) * sizeof(klientDane));
 
 klientDane klient;
 kasujPlik.read(reinterpret_cast<char *>(&klient),
                   sizeof(klientDane));

 if(klient.kontoNumer != 0){
  klientDane pustyKlient = { 0, "", "", 0.0};

  kasujPlik.seekp((konto - 1) * sizeof(klientDane));

  kasujPlik.write(reinterpret_cast<const char *>(&pustyKlient),
                  sizeof(klientDane));

  cout << "Konto #" << konto << " skasowane. " << endl;
 }
 else
                                                                                               
  cout << "Konto #" << konto << " jest puste." << endl;
}

// wypisz wiersz z informacjami o kliencie
void wyWiersz(ostream &wyjscie, const klientDane &k)
{
 wyjscie << setiosflags( ios::left ) << setw(10) 
         << k.kontoNumer << setw(16) << k.Nazwisko
         << setw(11) << k.Imie << setw(10)
         << setprecision(2) << resetiosflags( ios::left )
         << setiosflags(ios::fixed | ios::showpoint)
         << k.bilans << endl;
}

// pobierz numer konta z klawiatury
int wezKonto(const char *pytanie)
{ 
  int konto;

  do{
    cout << pytanie << "(1-100): ";
    cin  >> konto;
  }while(konto < 1 || konto > 100);

  return konto;
}             
  