// program which illustrates using C++ exceptions 
// to manage various kinds of runtime errors

#include<iostream.h>
#include<math.h>
#include<conio.h>

const BAD_RESULT = -1.0e+100;

class TOperatorException{};
TOperatorException InvalidOperatorError; 

class TZeroDivisionException{};
TZeroDivisionException ZeroDivideError; 

class TPowerToNegNumException{};
TPowerToNegNumException PowerOfNegNumError;

class TOperation
{
  public:

    TOperation();

    void SetOperand1(double x)
    { X = x; }

    void SetOperand2(double y)
    { Y = y; }

    void SetOperator(char op)
    { Op = op; }

    double Add()
    { return X + Y; }

    double Sub()
    { return X - Y; } 

    double Mul()
    { return X * Y; } 

    double Div()   throw(TZeroDivisionException);

    double Power() throw(TPowerToNegNumException);

    double Calculate();

  protected:

    double X;
    
    double Y;

    char   Op;  

};

TOperation::TOperation()
{
 X  = 0;
 Y  = 0;
 Op = ' ';
}

double TOperation:: Div()
throw(TZeroDivisionException)
{
 if(Y!=0)
   return X/Y;
 else 
   throw(ZeroDivideError);
}

double TOperation::Power()
throw(TPowerToNegNumException)
{ 
 if(X<0)
   throw(PowerOfNegNumError);
 else
   return exp(log(X) * Y);
}

double TOperation::Calculate()
{
  double Z = BAD_RESULT;

  try {
   switch(Op){

   case '+' : Z = Add();   break;
   case '-' : Z = Sub();   break;
   case '*' : Z = Mul();   break;
   case '/' : Z = Div();   break;
   case '^' : Z = Power(); break;
   default  : throw(InvalidOperatorError);
   }
 }
 catch(TOperatorException)
 { 
  cout << "Error : The operator '" << Op << "' is not valid";
 }
 catch(TZeroDivisionException)
 {
  cout << "Error: Attemt to divide by zero";
 }
 catch(...)
 {
  cout << "Error : Atttempt to raise power of a negative number";
 }
 return Z;
}
main()
{ 
 char       answer, op;
 double     x, y, z;
 TOperation Operation;

 do{

   cout << "\n\nEnter first operand : ";
   cin  >> x;

   cout << "Enter second operand : ";
   cin  >> y;

   cout << "Enter operator : ";
   cin  >> op;

   cout << "\n\n";

   Operation.SetOperand1(x);
   Operation.SetOperand2(y);
   Operation.SetOperator(op);
   z = Operation.Calculate();

   if(z > BAD_RESULT)
    { cout << x << " " << op << " "
           << y << " = " << z << endl;
    }

   cout << "\nWant to perform more calculations? (Y/N)";
   answer = getche();

 }while(answer == 'Y' || answer == 'y');

 return 0;
}           

/*
Enter first operand : 5
Enter second operand : 0
Enter operator : /

Error: Attemt to divide by zero
Want to perform more calculations? (Y/N)y
*/
           
   
         
   
         
    